unit ifGravityTrue;

interface
uses informationfield, BoolField, Classes, Math,
  Windows, Messages, SysUtils, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls, ToolWin, ComCtrls, Menus, Buttons, StdCtrls,
  ActnList;

type CObj = class
  public
  x: Longint;            //
  y: Longint;
  vX: Double; vY: Double;    // 
  m: Double;              //
  sX: Double; sY: Double;  //
  aX: Double; aY: Double; //

  function GetMinTime(s: Double): Double;
    //        s   X  Y
    //     ,   1

  published
    Constructor Create(x : Longint; y: Longint; vX: Double; vY: Double; m: Double);
end;

const G = 1.00; // 

type               //  
  CifGravityTrue = class(CInformatiomField)
    public

            ObjLst: TList;
//            objFeald: array of array of ^CObj;

      procedure OneStep(
        ColCount, RowCount: Longint;
        var boolCell: TBoolField;
        var nextPopulation: Longint;
        var bornPopulation, todPopulation: Integer ); override;

      procedure CallForcePoten( //     
        var obj1: CObj; var obj2: CObj
        );

  end;

var
  curIfGravityTrue: CifGravityTrue;

implementation
//uses Windows, Sysutils;


function GetSqrtEq(a,b,c: Double) : Double;
//         1
var D, x1, x2:Double;
begin
  D:= b*b - (4*a*c); //// .
  result:= -1;
  if (D >= 0) and ( (a<>0) or (b<>0) ) then begin
    if a=0 then begin
      if b <> 0 then begin
        x1 := -c/b;
        x2 := x1;
      end;
    end
    else begin
      x1 := (-b + Sqrt(D))/(2*a); //  
      x2:= (-b - Sqrt(D))/(2*a); //  .
    end;
    if (x1 <=0) and  (x2 <= 0) then result:= -1
    else begin
      if x1 < 0 then result := x2
      else begin
        if x2 < 0 then result := x1
        else begin
          result := x1;
          if x1 > x2 then result := x2;
        end;
      end;
    end;
  end;
end; //function GetSqrtEq



function CObj.GetMinTime(s: Double): Double; //        s   X  Y
begin

  result := -1;
end; //function CObj.GetMinTime(s: Double): Double;

constructor CObj.Create(x : Longint; y: Longint; vX: Double; vY: Double; m: Double);
begin
   Self.x := x; Self.y := y; Self.vX := vX; Self.vY := vY; Self.m := m;
   Self.sX:=0; Self.sY:=0;
   Self.aX:=0; Self.aY:=0;

end;



procedure CifGravityTrue.CallForcePoten( //     
        var obj1: CObj; var obj2: CObj
        );
var f, fX, fY: Double;
begin
  if  Sqr(obj1.x+obj1.sX-obj2.x-obj2.sX) + Sqr(obj1.y+obj1.sY-obj2.y-obj2.sY) = 0 then
    f := g*obj1.m*obj2.m/Power( 0.5, 3/2 )
  else
    f := g*obj1.m*obj2.m/
    Power( Sqr(obj1.x+obj1.sX-obj2.x-obj2.sX) + Sqr(obj1.y+obj1.sY-obj2.y-obj2.sY), 3/2 );
  fX := f*(obj2.x + obj2.sX - obj1.x - obj1.sX); fY := f*(obj2.y+obj2.sY-obj1.y-obj1.sY);
  obj1.aX :=  obj1.aX + fX/obj1.m; obj2.aX := obj2.aX - fX/obj2.m;
  obj1.aY :=  obj1.aY + fY/obj1.m; obj2.aY := obj2.aY - fY/obj2.m;


end; //procedure CallForcePoten


procedure CifGravityTrue.OneStep(
      ColCount, RowCount: Longint;
      var boolCell: TBoolField;
      var nextPopulation: Longint;
      var bornPopulation, todPopulation: Integer );
var i, j: Longint;
var tmpM, tmpVx, tmpVy, minT, tmpT, tmpS, minS, v1, v2, s11, s12, s21, s22, ss: Double;
var questStr: string;
var obj1, obj2, hitObj:CObj;
var nighObj: TList;
var isIntersect: Boolean;



begin
  if not Assigned(ObjLst) then begin  //    
    ObjLst := TList.Create;

//    SetLength(objFeald, ColCount, RowCount);

    tmpM := 1; tmpVx := 0; tmpVy := 0;
    for  i:=0 to ColCount-1 do
      for j:=0 to RowCount-1 do begin
        if  boolCell[i,j] then begin
            questStr := '    ' + IntToStr(i) + ', ' + IntToStr(j);
            tmpM := StrToFloat(InputBox(questStr,'', FloatToStr(tmpM)));
            tmpVx := StrToFloat(InputBox(questStr,'   ', FloatToStr(tmpVx)));
            tmpVy := StrToFloat(InputBox(questStr,'   Y', FloatToStr(tmpVy)));
            obj1 := CObj.Create(i,j,tmpVx, tmpVy,tmpM);
            ObjLst.Add(obj1);

//            objFeald[i,j] := @obj1;
        end;
    end;

  end; //if not Assigned(Objects) then begin

  //!!!  -        
  for i:=0 to ObjLst.Count-1 do begin // 
    CObj(ObjLst[i]).aX:=0; CObj(ObjLst[i]).aY:=0;
  end;
  for i:=0 to ObjLst.Count-1 do begin
    obj1 := CObj(ObjLst[i]);
    for j:=i+1 to ObjLst.Count-1 do begin
      obj2 := CObj(ObjLst[j]);
      CallForcePoten(obj1, obj2);
    end; //for i:=0 to ObjLst.Count-1 do begin
  end; //for j:=i to ObjLst.Count-1 do begin

  //           
  minT := -1;
  for i:=0 to ObjLst.Count-1 do begin
    obj1 := CObj(ObjLst[i]);
    tmpT := GetSqrtEq(obj1.aX/2, obj1.vX, obj1.sX+1.0);
    if (tmpT > 0) and ((minT > tmpT) or (minT<0)) then minT := tmpT;

    tmpT := GetSqrtEq(obj1.aX/2, obj1.vX, obj1.sX-1.0);
    if (tmpT > 0) and ((minT > tmpT) or (minT<0)) then minT := tmpT;


    tmpT := GetSqrtEq(obj1.aY/2, obj1.vY, obj1.sY+1.0);
    if (tmpT > 0) and ((minT > tmpT) or (minT<0)) then minT := tmpT;

    tmpT := GetSqrtEq(obj1.aY/2, obj1.vY, obj1.sY-1.0);
    if (tmpT > 0) and ((minT > tmpT) or (minT<0)) then minT := tmpT;
  end;

  if minT > 0 then begin



  //   
  nighObj := TList.Create;
  for i:=0 to ObjLst.Count-1 do begin
     obj1 := CObj(ObjLst[i]);
     nighObj.Clear;

     hitObj := nil; minS := 100;
     for j:=0 to ObjLst.Count-1 do begin
       if j <> i then begin
         obj2 := CObj(ObjLst[j]);
         isIntersect := false;

         tmpS := Sqr(obj1.x + obj1.sX + obj1.vX * minT + obj1.aX/2 * minT * minT
                  -
                  1.0 * (obj2.x + obj2.sX + obj2.vX * minT + obj2.aX/2 * minT * minT))
              +
                 Sqr(obj1.y + obj1.sY + obj1.vY * minT + obj1.aY/2 * minT * minT
                 -
                 1.0 * (obj2.y + obj2.sY + obj2.vY * minT + obj2.aY/2 * minT * minT));

         if tmpS <= 2 then begin
           s11 := obj1.x + obj1.sX;
           s12 := obj1.x + obj1.sX + obj1.vX * minT + obj1.aX/2 * minT * minT;
           if s11>s12 then begin
             ss:=s12; s12:=s11; s11:=ss;
           end;
           s21:=obj2.x + obj2.sX;
           s22:=obj2.x + obj2.sX + obj2.vX * minT + obj2.aX/2 * minT * minT;
           if s21>s22 then begin
             ss:=s22; s22:=s21; s21:=ss;
           end;

           if (s11<>s12) and (s21<>s22) and  (((s21>=s11) and (s21<=s12)) or ((s22>=s11) and (s22<=s12))
              or ((s11>=s21) and (s11<=s22)) or ((s12>=s21) and (s12<=s22))) then isIntersect := true;

           s11 := obj1.y + obj1.sY;
           s12 := obj1.y + obj1.sY + obj1.vY * minT + obj1.aY/2 * minT * minT;
           if s11>s12 then begin
             ss:=s12; s12:=s11; s11:=ss;
           end;
           s21:=obj2.y + obj2.sY;
           s22:=obj2.Y + obj2.sY + obj2.vY * minT + obj2.aY/2 * minT * minT;
           if s21>s22 then begin
             ss:=s22; s22:=s21; s21:=ss;
           end;

           if (s11<>s12) and (s21<>s22) and  (((s21>=s11) and (s21<=s12)) or ((s22>=s11) and (s22<=s12))
              or ((s11>=s21) and (s11<=s22)) or ((s12>=s21) and (s12<=s22))) then isIntersect := true;


         end; //if tmpS <= 1


         if isIntersect and (minS > tmpS) then begin
           nighObj.Add(obj2);
           hitObj := obj2;
           minS := tmpS;
         end;
       end; //if
     end; //for j

     if hitObj <> nil then begin // !
       if Sqr(  obj1.x + obj1.sX + obj1.vX * minT + obj1.aX/2 * minT * minT
             - 1.0 * (hitObj.x + hitObj.sX + hitObj.vX * minT + hitObj.aX/2 * minT * minT) )
           >
           Sqr( obj1.y + obj1.sY + obj1.vY * minT + obj1.aY/2 * minT * minT
                 - 1.0 * (hitObj.y + hitObj.sY + hitObj.vY * minT + hitObj.aY/2 * minT * minT)  )
       then begin //   
         v1 := ((obj1.m - hitObj.m)*obj1.vX + 2*hitObj.m*hitObj.vX)/(obj1.m + hitObj.m);
         v2 := ((-obj1.m + hitObj.m)*hitObj.vX + 2*obj1.m*obj1.vX)/(obj1.m + hitObj.m);
         obj1.vX := v1;
         hitObj.vX := v2;
       end
       else begin //   Y
         v1 := ((obj1.m - hitObj.m)*obj1.vY + 2*hitObj.m*hitObj.vY)/(obj1.m + hitObj.m);
         v2 := ((-obj1.m + hitObj.m)*hitObj.vY + 2*obj1.m*obj1.vY)/(obj1.m + hitObj.m);
         obj1.vY := v1;
         hitObj.vY := v2;
       end;

     end;//if hitObj <> nil
  end; //for i



  //  
  for i:=0 to ObjLst.Count-1 do begin
     obj1 := CObj(ObjLst[i]);


     if( (obj1.x >= 0) and (obj1.x < ColCount) and (obj1.y >= 0) and (obj1.y < RowCount) ) then
       boolCell[obj1.x, obj1.y] :=  false;

    obj1.sX := obj1.sX + obj1.vX * minT + obj1.aX/2 * minT * minT;
    obj1.vX := obj1.vX + obj1.aX * minT;
    if obj1.sX <= -0.99999 then begin  // 1 , ..       
       obj1.x := obj1.x-1;
       obj1.sX := 0;
     end;
     if obj1.sX >= 0.99999 then begin
       obj1.x := obj1.x+1;
       obj1.sX := 0;
     end;

     obj1.sY := obj1.sY + obj1.vY * minT + obj1.aY/2 * minT * minT;
     obj1.vY := obj1.vY + obj1.aY * minT;
     if obj1.sY <= -0.99999 then begin
       obj1.y := obj1.y-1;
       obj1.sY := 0;
     end;
     if obj1.sY >= 0.99999 then begin
       obj1.y := obj1.y+1;
       obj1.sY := 0;
     end;

     if( (obj1.x >= 0) and (obj1.x < ColCount) and (obj1.y >= 0) and (obj1.y < RowCount) ) then
       boolCell[obj1.x, obj1.y] :=  true;

  end;

  end;//if minT > 0 




end;




end.
