unit ifGravityTrue;

interface                                                                  
uses informationfield, BoolField, Classes,
  Windows, Messages, SysUtils, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls, ToolWin, ComCtrls, Menus, Buttons, StdCtrls,
  ActnList;

type
  TInterectDirection = (intX,intY,intXY, notInt);

type CObj = class
  public
  x: Longint;            //
  y: Longint;
  vX: Double; vY: Double;    // 
  m: Double;              //
  sX: Double; sY: Double;  //
  aX: Double; aY: Double; //
//  Tm: Double; // 
  color: TColor;
  name: String;


  procedure Step(t:Double); //   t

  published
    Constructor Create(x : Longint; y: Longint; vX: Double; vY: Double; m: Double; name: String; color: TColor);
end;

type CComplexObj = class(CObj)  // 
  public
//  m: Double;
//  vX: Double;
//  vY: Double;
  objLst: TList;
  function IsObjInList(obj:CObj): boolean;
  procedure Add( newObj: CObj);
  procedure SetV( vX, vY: Double); //      v


  private
  procedure CallAllVal; //     !


  published
    Constructor Create;
end; //type CComplObj

type CComplexObjList = class
  public
  complObjLst: TList;
  function  FindeObj( obj: CObj): CComplexObj;
  procedure Clear;

    published
    Constructor Create;

end; //type CComlexObjList

type               //  
  CifGravityTrue = class(CInformatiomField)
    public
            G: Double; // = 1.00; // 
            ObjLst: TList;
            complexObjects: CComplexObjList;
//            objFeald: array of array of ^CObj;
            sumTime: Double;
            Stepsic: Longint; //      ,          1/1000  = 100000;


      procedure OneStep(
        ColCount, RowCount: Longint;
        var boolCell: TBoolField;   var trackCell: TBoolField;
        var nextPopulation: Longint;
        var bornPopulation, todPopulation: Integer ); override;

      procedure CallForcePoten( //     
        var obj1: CObj; var obj2: CObj
        );

      procedure CallForcePotenForAll; //     
      function GetObjXY( x,y: Longint ): CObj; //      X Y
      function GetMinTimeStep(step: Double): Double; //           
      function GetMinComplexTimeStep(step: Double): Double;
                      //          step 

      function GetMinIntersectTime( t:Double) : Double;//       
                                                   //   
      function GetMinComplexIntersectTime(t: Double) : Double;//       

      procedure StepAll( t: Double); //    t
      procedure IntersectCall;
      procedure CreateComlexObjList(minT : Double);
  end;

var
  curIfGravityTrue: CifGravityTrue;

const
  RoundToRange:Integer = -10;

implementation
//uses Windows, Sysutils;
  uses Math, main, askBeginVal;


  constructor CComplexObj.Create;
  begin
   Self.ObjLst := TList.Create;

  end;

  constructor CComplexObjList.Create;
  begin
   Self.ComplObjLst := TList.Create;

  end;

  procedure CComplexObj.Add( newObj: CObj);
  begin
    if not IsObjInList( newObj ) then begin
      objLst.Add( newObj );
      CallAllVal;
    end; //if not IsObjInList( newObj )

  end;

  function CifGravityTrue.GetObjXY( x,y: Longint ): CObj; //      X Y
  var i: Longint;
  var curObj: CObj;

  begin
     result := nil;
    for i:=0 to ObjLst.Count-1 do begin
      curObj := CObj(ObjLst[i]);
      if (curObj.x = x) and (curObj.y = y) then begin
        result:= curObj;
        break;
      end;
    end; //for


  end;



  procedure CComplexObj.CallAllVal;
  var i: Integer;
  var curObj: CObj;
  var sumE, sumIx, sumIy, sumVx, sumVy, sumAx, sumAy, sumX, sumY, sumM: Double;
  begin
  sumE := 0; sumIx := 0; sumIy := 0; sumVx := 0; sumVy := 0;
  sumAx := 0; sumAy := 0; sumX := 0; sumY := 0; sumM := 0;
  for i:=0 to ObjLst.Count-1 do begin
    curObj := CObj(ObjLst[i]);
    sumE := sumE + curObj.m*(curObj.vX*curObj.vX +curObj.vY*curObj.vY);
    sumIx := sumIx + curObj.m*curObj.vX;
    sumIy := sumIy + curObj.m*curObj.vY;
    sumVx := sumVx + curObj.m*curObj.vX;
    sumVy := sumVy + curObj.m*curObj.vY;
//    sumAx := SimpleRoundTo(sumAx + curObj.m*curObj.aX, RoundToRange);
    sumAx := sumAx + curObj.m*curObj.aX;
    sumAy := sumAy + curObj.m*curObj.aY;
    sumX:= sumX + curObj.m*(curObj.x + curObj.sX);
    sumY:= sumY + curObj.m*(curObj.y + curObj.sY);
    sumM := sumM+curObj.m;
  end; //for
//  if sumE = 0 then m:=0 else m := SimpleRoundTo((sumIx*sumIx + sumIy*sumIy)/sumE, RoundToRange);
//  if m <> 0 then begin
//    vX := SimpleRoundTo(sumVx/m, RoundToRange);
//    vY := SimpleRoundTo(sumVy/m, RoundToRange);
  if sumM <> 0 then begin
    vX := sumVx/sumM;
    vY := sumVy/sumM;
  end
  else begin
    vX := 0;
    vY := 0;
  end;

  if sumM <= 0 then sumM := 1;

  aX := sumAx/sumM;
  aY := sumAy/sumM;
  x := Trunc(sumX/sumM);
  sX := Frac(sumX/sumM);
  y := Trunc(sumY/sumM);
  sY := Frac(sumY/sumM);
  m := sumM;

  end; //procedure CComplexObj.CallM;

  function CComplexObj.IsObjInList(obj:CObj): boolean;
  var i: Integer;
  var curObj: CObj;
  begin
  result := false;
  for i:=0 to ObjLst.Count-1 do begin
    curObj := CObj(ObjLst[i]);
    if curObj = obj then begin
      result := true;
      break;
    end;
  end; //for
  end; //function CComplexObj:IsObjInList(obj:CObj): boolean;


  function   CComplexObjList.FindeObj( obj: CObj): CComplexObj;
  var i: Integer;
  var curComplexObj: CComplexObj;
  begin
  result := nil;
  for i:=0 to ComplObjLst.Count-1 do begin
    curComplexObj := CComplexObj(ComplObjLst[i]);
    if curComplexObj.IsObjInList(obj) then begin
      result := curComplexObj;
      break;
    end;
  end; //for
  end; //function  CComplexObjList.CFindeObj( obj: CObj): CComplexObj;

  procedure  CComplexObjList.Clear;
  var i: Integer;
  var curComplexObj: CComplexObj;
  begin
//  if Assigned(ComplObjLst) then
  for i:=0 to ComplObjLst.Count-1 do begin
    curComplexObj := CComplexObj(ComplObjLst[i]);
    curComplexObj.objLst.Clear;
    curComplexObj.objLst.Free;
    curComplexObj.Free;
  end; //for
  ComplObjLst.Clear;
  end; //procedure  CComlexObjList.Clear

function Sgn(i:integer):integer;
begin
 if i<>0 then Sgn:=round(i/abs(i))
 else Sgn:=1
end;

  function GetSqrtEq(a,b,c: Double) : Double;
//         1
var D, x1, x2:Double;
begin
  D:= b*b - (4*a*c); //// .
  x1:=-1; x2:=-1;
  result:= -1;
  if (D >= 0) and ( (a<>0) or (b<>0) ) then begin
    if Abs(a) < 1e-20 then begin
      if b <> 0 then begin
        x1 := -c/b;
        x2 := x1;
      end;
    end
    else begin
      x1 := (-b + Sqrt(D))/(2*a); //  
      x2:= (-b - Sqrt(D))/(2*a); //  .
    end;
    if (x1 <0) and  (x2 < 0) then result:= -1
    else begin
      if (x1 < 0)  then result := x2 ///*or (Abs(x1) < 0.00000000001)*/
      else begin
        if (x2 < 0) then result := x1
        else begin
          result := x1;
          if (x2 < x1) and (x2 > 1e-15) then result := x2;
        end;
      end;
    end;
  end;
//  else if (Abs(D)<0.0000000001) and (Abs(a)<0.0000000001) and (Abs(b)<0.0000000001) then result := 0;
end; //function GetSqrtEq



function GetIntersectTime(obj1, obj2: CObj; t: Double;
   var intDir:TInterectDirection): Double;
//       -1
var TminY, TminX, x11, x12, x21, x22, y11, y12, y21, y22, dX, dY: Double;
begin
  result := -1;
  intDir := notInt;
  TminX := -1; TminY := -1;

  dX := 0;
  if (obj1.x + obj1.sX) < (obj2.x + obj2.sX) then dX := +0.5;
  if (obj1.x + obj1.sX) > (obj2.x + obj2.sX) then dX := -0.5;
  x11 := Min(obj1.x + obj1.sX,
             obj1.x + obj1.sX + dX + obj1.vX * t + obj1.aX * t * t/2);
  x12 := Max(obj1.x + obj1.sX,
             obj1.x + obj1.sX + dX + obj1.vX * t + obj1.aX * t * t/2);
  x21 := Min(obj2.x + obj2.sX,
             obj2.x + obj2.sX - dX + obj2.vX * t + obj2.aX * t * t/2);
  x22 := Max(obj2.x + obj2.sX,
             obj2.x + obj2.sX - dX + obj2.vX * t + obj2.aX * t * t/2);

  dY := 0;
  if (obj1.y + obj1.sY) < (obj2.y + obj2.sY) then dY := +0.5;
  if (obj1.y + obj1.sY) > (obj2.y + obj2.sY) then dY := -0.5;
  y11 := Min( obj1.y + obj1.sY,
              obj1.y + obj1.sY + dY + obj1.vY * t + obj1.aY * t * t/2);
  y12 := Max(obj1.y + obj1.sY,
             obj1.y + obj1.sY + dY + obj1.vY * t + obj1.aY * t * t/2);
  y21 := Min(obj2.y + obj2.sY,
             obj2.y + obj2.sY - dY + obj2.vY * t + obj2.aY * t * t/2);
  y22 := Max(obj2.y + obj2.sY,
             obj2.y + obj2.sY - dY + obj2.vY * t + obj2.aY * t * t/2);

  if (SimpleRoundTo((x11 - x22)*(x21 - x12), RoundToRange) >= 0)
     and (SimpleRoundTo((y11 - y22)*(y21 - y12), RoundToRange) >= 0) then begin // !   
    if (Abs(SimpleRoundTo(obj1.x + obj1.sX - obj2.x - obj2.sX, RoundToRange)) <= 1) and
       (Abs(SimpleRoundTo(obj1.y + obj1.sY - obj2.y - obj2.sY, RoundToRange)) <= 1) then begin
      result := 0;
    end
    else begin
           if Abs(SimpleRoundTo(obj1.x + obj1.sX - obj2.x - obj2.sX, RoundToRange)) >= 1 then
             TminX := GetSqrtEq( (obj1.aX - obj2.aX)/2, obj1.vX-obj2.vX,
                               obj1.x + obj1.sX - obj2.x - obj2.sX + 2*dX);

           if Abs(SimpleRoundTo(obj1.y + obj1.sY - obj2.y - obj2.sY, RoundToRange)) >= 1 then
             TminY := GetSqrtEq( (obj1.aY - obj2.aY)/2, obj1.vY-obj2.vY,
                                obj1.y + obj1.sY - obj2.y - obj2.sY + 2*dY);

           if ((TminY>=0) and (TminX>=TminY)) or (TminX<0) then begin
             if TminX = TminY then intDir := intXY else intDir := intY;
             TminX := TminY;
             end
           else intDir := intX;

           result := TminX;
    end;
//          if Abs(TminX - TminY) < 1e-20 then result := Min(TminX, TminY);


  end; //if ((x11 - x22)*(x21 - x12)) >= 0) and ((y11 - y22)*(y21 - y12)) >= 0)


  if result = 0 then begin //  
    if  ( obj1.x <> obj2.x) and
       (SimpleRoundTo(Abs(obj1.x + obj1.sX + obj1.vX * t  + obj1.aX*t*t/2
         - obj2.x - obj2.sX - obj2.vX * t - obj2.aX*t*t/2), RoundToRange) - 1 >= 0)
     then  begin
       result := -1;
     end;

    if (obj1.y <> obj2.y) and
       (SimpleRoundTo(Abs(obj1.y + obj1.sY + obj1.vY * t  + obj1.aY*t*t/2
         - obj2.y - obj2.sY - obj2.vY * t - obj2.aY*t*t/2), RoundToRange) - 1  >=  0)
     then begin
       result := -1;
     end;

  end;


end; //function GetIntersectTime


procedure CifGravityTrue.StepAll( t: Double); //    t
var obj1: CObj;
var i: Integer;
begin
  for i:=0 to ObjLst.Count-1 do begin
    obj1 := CObj(ObjLst[i]);
    obj1.Step(t);
  end;
  sumTime := sumTime + t;
end; //procedure CifGravityTrue.StepAll



function CifGravityTrue.GetMinTimeStep(step: Double): Double;
  //           
var obj1: CObj;
var i: Longint;
var tmpT, minT: Double;
begin
  minT := -1;
  for i:=0 to ObjLst.Count-1 do begin
    obj1 := CObj(ObjLst[i]);
    tmpT := GetSqrtEq(obj1.aX/2, obj1.vX, -step);
    if (tmpT > 0) and ((minT > tmpT) or (minT<0)) then minT := tmpT;

    tmpT := GetSqrtEq(obj1.aX/2, obj1.vX, +step);
    if (tmpT > 0) and ((minT > tmpT) or (minT<0)) then minT := tmpT;


    tmpT := GetSqrtEq(obj1.aY/2, obj1.vY, -step);
    if (tmpT > 0) and ((minT > tmpT) or (minT<0)) then minT := tmpT;

    tmpT := GetSqrtEq(obj1.aY/2, obj1.vY, +step);
    if (tmpT > 0) and ((minT > tmpT) or (minT<0)) then begin
      minT := tmpT;

       //            1/1000
       Stepsic := Round(1e+6*Max(Abs(obj1.aX), Abs(obj1.aY))*minT);
       if(Stepsic < 100000) then Stepsic:= 100000;
       if (Stepsic > 10000000) then Stepsic := 10000000;
    end;

  end;


  result:= minT;

end; //function CifGravityTrue.GetMinTimeStep

function CifGravityTrue.GetMinIntersectTime(t: Double) : Double;//       
                                                   //       t
var obj1,obj2: CObj;
var i,j: Integer;
var Tint, minT: Double;
var intDir: TInterectDirection;
begin
  minT := -1;
  for i:=0 to ObjLst.Count-2 do begin
     obj1 := CObj(ObjLst[i]);
     for j:=i+1 to ObjLst.Count-1 do begin
         obj2 := CObj(ObjLst[j]);
           Tint := GetIntersectTime(obj1, obj2, t, intDir);
           if (Tint>=0) and (Tint <= t)   then begin // !
             if (minT<0) or (minT>Tint) then begin
               minT := Tint;
               if (minT = 0 ) then begin
                 result := 0;
                 exit;
               end;
             end;
           end;
     end; //for j
   end; //for i
   result := minT;
end; //CifGravityTrue.GetMinInterectTime

function CifGravityTrue.GetMinComplexIntersectTime(t: Double) : Double;//       
                                                   //       t
var obj1,obj2: CObj;
var complexObj1, complexObj2: CComplexObj;
var i,j: Integer;
var Tint, minT: Double;
var intDir: TInterectDirection;
begin
  minT := -1;
  for i:=0 to ObjLst.Count-2 do begin
    obj1 := CObj(ObjLst[i]);
    complexObj1 := complexObjects.FindeObj(obj1);
     for j:=i+1 to ObjLst.Count-1 do begin
       obj2 := CObj(ObjLst[j]);
       complexObj2 := complexObjects.FindeObj(obj2);
       if (complexObj1 = nil) or (complexObj1 <> complexObj2) then begin
//  for i:=0 to complexObjects.complObjLst.Count-2 do begin
//     complexObj1 := CComplexObj(complexObjects.complObjLst[i]);
//     for j:=0 to complexObj1.objLst.Count-1 do begin
//       obj1 := CObj(complexObj1.objLst[j]);
//       for k:=i+1 to complexObjects.complObjLst.Count-1 do begin
//         complexObj2 := CComplexObj(complexObjects.complObjLst[k]);
//         for l:=0 to complexObj2.objLst.Count-1 do begin
//           obj2 := CObj(complexObj2.objLst[l]);
           Tint := GetIntersectTime(obj1, obj2, t, intDir);
           if (Tint>=0) and (Tint <= t)   then begin // !
             if (minT<0) or (minT>Tint) then begin
               minT := Tint;
               if (minT = 0 ) then begin
                 result := 0;
                 exit;
               end;
             end;
           end;
        end; //if (complexObj1 = nil) or (complexObj1 <> complexObj2) do begin
     end; //for j
   end; //for i
   result := minT;
end; //CifGravityTrue.GetMinInterectTime


function CifGravityTrue.GetMinComplexTimeStep(step: Double): Double;
  //          step 
var obj1: CObj;
var i: Longint;
var tmpT, minT: Double;
begin
  minT := -1;
  for i:=0 to complexObjects.complObjLst.Count-1 do begin
    obj1 := CObj(complexObjects.complObjLst[i]);
    tmpT := GetSqrtEq(obj1.aX/2, obj1.vX, obj1.sX-step);
    if (tmpT > 0) and ((minT > tmpT) or (minT<0)) then minT := tmpT;

    tmpT := GetSqrtEq(obj1.aX/2, obj1.vX, obj1.sX+step);
    if (tmpT > 0) and ((minT > tmpT) or (minT<0)) then minT := tmpT;


    tmpT := GetSqrtEq(obj1.aY/2, obj1.vY, obj1.sY-step);
    if (tmpT > 0) and ((minT > tmpT) or (minT<0)) then minT := tmpT;

    tmpT := GetSqrtEq(obj1.aY/2, obj1.vY, obj1.sY+step);
    if (tmpT > 0) and ((minT > tmpT) or (minT<0)) then minT := tmpT;

    if minT > 0 then begin //            1/1000
       Stepsic  := Round(1e+5*Max(Abs(obj1.aX), Abs(obj1.aY))*minT);
//       if(Stepsic < tmpStep) then
       if(Stepsic < 10000) then Stepsic:= 10000;
       if (Stepsic > 1000000) then Stepsic := 1000000;
    end;

  end;
  result := minT;
end; //function CifGravityTrue.GetMinTimeStep


constructor CObj.Create(x : Longint; y: Longint; vX: Double; vY: Double; m: Double; name: String; color: TColor);
begin
   Self.x := x; Self.y := y; Self.vX := vX; Self.vY := vY; Self.m := m;
   Self.sX:=0; Self.sY:=0;
   Self.aX:=0; Self.aY:=0;
   Self.name := name;
   Self.color := color

end;

procedure CObj.Step (t:Double);
begin
         sX := sX + vX * t + aX * t * t /2;
         vX := vX + aX * t;

         sY := sY + vY * t + aY * t * t /2;
         vY := vY + aY * t;

//         sumTime := sumTime + t;
//         Tm := Tm - t;

end; //procedure Cobj.Step (t:Double);



//  
procedure CifGravityTrue.IntersectCall;
var i, j: Longint;
var curObj, tmpObj: CObj;
var v1x, v1y, v2x, v2y, curM, tmpM: Double;
var curComplObj, tmpComplObj, intComplObj: CComplexObj;
var endCurObjX, endCurObjY, endTmpObjX, endTmpObjY: Double;
var begCurObjX, begCurObjY, begTmpObjX, begTmpObjY: Double;


begin
  intComplObj := nil;
  for i:=0 to ObjLst.Count-1 do begin
    curObj := CObj(ObjLst[i]);
    curComplObj := complexObjects.FindeObj( curObj );
    for j:=i+1 to ObjLst.Count-1 do begin
      tmpObj := CObj(ObjLst[j]);
      tmpComplObj := complexObjects.FindeObj( tmpObj );
      if (intComplObj =  tmpComplObj) and (tmpComplObj <> nil ) then continue;


      if (curComplObj = nil) or (curComplObj <> tmpComplObj) then begin

        begCurObjX := curObj.x+curObj.sX - 0.5;
        begTmpObjX := tmpObj.x+tmpObj.sX - 0.5;
        endCurObjX := curObj.x+curObj.sX + 0.5;
        endTmpObjX := tmpObj.x+tmpObj.sX + 0.5;
        begCurObjY := curObj.y+curObj.sY - 0.5;
        begTmpObjY := tmpObj.y+tmpObj.sY -0.5;
        endCurObjY := curObj.y+curObj.sY + 0.5;
        endTmpObjY := tmpObj.y+tmpObj.sY + 0.5;

      if (SimpleRoundTo((begCurObjX - endTmpObjX)*(begTmpObjX - endCurObjX), RoundToRange) >= 0) and
      (SimpleRoundTo((begCurObjY - endTmpObjY)*(begTmpObjY - endCurObjY), RoundToRange) >= 0) then begin
          if (curComplObj <> nil) then curM :=  curComplObj.m else curM := curObj.m;
          if (tmpComplObj <> nil) then tmpM :=  tmpComplObj.m else tmpM := tmpObj.m;

          v1x := ((curM - tmpM)*curObj.vX + 2*tmpM*tmpObj.vX)/(curM + tmpM);
          v2x := ((-curM + tmpM)*tmpObj.vX + 2*curM*curObj.vX)/(curM + tmpM);
          v1y := ((curM - tmpM)*curObj.vY + 2*tmpM*tmpObj.vY)/(curM + tmpM);
          v2y := ((-curM + tmpM)*tmpObj.vY + 2*curM*curObj.vY)/(curM + tmpM);


          if (curComplObj <> nil) then curComplObj.SetV(v1x, v1y)
          else begin curObj.vX := v1x; curObj.vY := v1y; end;
          if (tmpComplObj <> nil) then tmpComplObj.SetV(v2x, v2y)
          else begin tmpObj.vX := v2x; tmpObj.vY := v2y; end;

          intComplObj := tmpComplObj;

        end;
      end; //if (curComplObj = nil) or (curComplObj <> tmpComplObj) then begin
    end; //for i:=0 to ObjLst.Count-1 do begin
  end; //for j:=i to ObjLst.Count-1 do begin

end; //procedure CifGravityTrue.InterectCall


procedure CifGravityTrue.CallForcePoten( //     
        var obj1: CObj; var obj2: CObj
        );
var f, fX, fY, r2: Double;
begin
  r2 := Sqr(obj1.x+obj1.sX-obj2.x-obj2.sX) + Sqr(obj1.y+obj1.sY-obj2.y-obj2.sY);
  if  r2 < 0.9999 then begin
     f := g*obj1.m*obj2.m/Power( 1.0, 3.0/2.0 );
  end
  else
    f := (g*obj1.m*obj2.m)/Power( r2, 3.0/2.0 );

  fX := f*(obj2.x + obj2.sX - obj1.x - obj1.sX); fY := f*(obj2.y+obj2.sY-obj1.y-obj1.sY);
//  obj1.aX :=  obj1.aX + fX/obj1.m; obj2.aX := obj2.aX - fX/obj2.m;
//  obj1.aY :=  obj1.aY + fY/obj1.m; obj2.aY := obj2.aY - fY/obj2.m;
  obj1.aX :=  obj1.aX + fX/Abs(obj1.m);
  obj2.aX := obj2.aX - fX/Abs(obj2.m);
  obj1.aY :=  obj1.aY + fY/Abs(obj1.m);
  obj2.aY := obj2.aY - fY/Abs(obj2.m);

end; //procedure CallForcePoten



  //!!!  -        
procedure CifGravityTrue.CallForcePotenForAll; //     
  var obj1: CObj;
  var obj2: CObj;
  var i,j: Integer;
begin

  for i:=0 to ObjLst.Count-1 do begin // 
    CObj(ObjLst[i]).aX:=0; CObj(ObjLst[i]).aY:=0;
  end;
  for i:=0 to ObjLst.Count-1 do begin
    obj1 := CObj(ObjLst[i]);
    for j:=i+1 to ObjLst.Count-1 do begin
      obj2 := CObj(ObjLst[j]);
      CallForcePoten(obj1, obj2);
    end; //for i:=0 to ObjLst.Count-1 do begin
  end; //for j:=i to ObjLst.Count-1 do begin

end; //procedure CallForcePotenForAll


procedure CifGravityTrue.CreateComlexObjList( minT: Double );
var i, j, k, m, n, p: Longint;
var curObj, tmpObj: CObj;
var endCurObjX, endCurObjY, endTmpObjX, endTmpObjY, v1, v2, Tint: Double;
var begCurObjX, begCurObjY, begTmpObjX, begTmpObjY: Double;
var curComplexObj, tempComplexObj,  curComplexObj2: CComplexObj;
var intDir: TInterectDirection;
var curLstX, curLstY, fullLstX, fullLstY: CComplexObj;

begin
//  complexObjects.complObjLst.Free;
  for i:=0 to ObjLst.Count-1 do begin
    curObj := CObj(ObjLst[i]);
    curComplexObj := complexObjects.FindeObj(curObj);
    for j:=i+1 to ObjLst.Count-1 do begin
      tmpObj := CObj(ObjLst[j]);
      tempComplexObj := complexObjects.FindeObj(tmpObj);

      if  (curComplexObj <> tempComplexObj) or
          ((curComplexObj = nil) and (tempComplexObj = nil))  then begin
        begCurObjX := curObj.x+curObj.sX - 0.5;
        begTmpObjX := tmpObj.x+tmpObj.sX - 0.5;
        endCurObjX := curObj.x+curObj.sX + 0.5;
        endTmpObjX := tmpObj.x+tmpObj.sX + 0.5;
        begCurObjY := curObj.y+curObj.sY - 0.5;
        begTmpObjY := tmpObj.y+tmpObj.sY -0.5;
        endCurObjY := curObj.y+curObj.sY + 0.5;
        endTmpObjY := tmpObj.y+tmpObj.sY + 0.5;

        if (SimpleRoundTo((begCurObjX - endTmpObjX)*(begTmpObjX - endCurObjX), RoundToRange) >= 0) and
        (SimpleRoundTo((begCurObjY - endTmpObjY)*(begTmpObjY - endCurObjY), RoundToRange) >= 0) then begin

         if curObj.x  = tmpObj.x then begin
           if (curObj.m + tmpObj.m) > 0 then begin
             v1 := ((curObj.m - tmpObj.m)*curObj.vY + 2*tmpObj.m*tmpObj.vY)/(curObj.m + tmpObj.m);
             v2 := ((-curObj.m + tmpObj.m)*tmpObj.vY + 2*curObj.m*curObj.vY)/(curObj.m + tmpObj.m);
           end
           else begin
             v1 := (curObj.vY + tmpObj.vY)/2;
             v2 := v1;
           end;
           curObj.vY := v1;
           tmpObj.vY := v2;
         end;
         if curObj.y = tmpObj.y then begin
           if (curObj.m + tmpObj.m) > 0 then begin
             v1 := ((curObj.m - tmpObj.m)*curObj.vX + 2*tmpObj.m*tmpObj.vX)/(curObj.m + tmpObj.m);
             v2 := ((-curObj.m + tmpObj.m)*tmpObj.vX + 2*curObj.m*curObj.vX)/(curObj.m + tmpObj.m);
           end
           else begin
             v1 := (curObj.vX + tmpObj.vX)/2;
             v2 := v1;
           end;
           curObj.vX := v1;
           tmpObj.vX := v2;
         end;

         if (curObj.x <> tmpObj.x) and (curObj.y <> tmpObj.y) then begin
           if (curObj.m + tmpObj.m) > 0 then begin
             v1 := ((curObj.m - tmpObj.m)*curObj.vY + 2*tmpObj.m*tmpObj.vY)/(curObj.m + tmpObj.m);
             v2 := ((-curObj.m + tmpObj.m)*tmpObj.vY + 2*curObj.m*curObj.vY)/(curObj.m + tmpObj.m);
             curObj.vY := v1;
             tmpObj.vY := v2;
             v1 := ((curObj.m - tmpObj.m)*curObj.vX + 2*tmpObj.m*tmpObj.vX)/(curObj.m + tmpObj.m);
             v2 := ((-curObj.m + tmpObj.m)*tmpObj.vX + 2*curObj.m*curObj.vX)/(curObj.m + tmpObj.m);
             curObj.vX := v1;
             tmpObj.vX := v2;
           end
           else begin
             curObj.vY := (curObj.vY + tmpObj.vY)/2;
             tmpObj.vY := curObj.vY;
             curObj.vX := (curObj.vX + tmpObj.vX) /2 ;
             tmpObj.vX := curObj.vX;
           end;

         end;


         Tint := GetIntersectTime(curObj, tmpObj, minT, intDir);
         if( Tint >= 0 ) and (Tint < 1e-20) then begin //  
           if  (not Assigned(curComplexObj)) and (not Assigned(tempComplexObj)) then begin
             curComplexObj := CComplexObj.Create;
             complexObjects.complObjLst.Add( curComplexObj );
             curComplexObj.Add( curObj );
             curComplexObj.Add( tmpObj );
           end
           else begin
             if (not Assigned(curComplexObj) ) then tempComplexObj.Add( curObj )
             else if (not Assigned(tempComplexObj) ) then curComplexObj.Add( tmpObj )
               else begin //       
                  for p:=tempComplexObj.objLst.Count - 1 downto 0  do begin
                    tmpObj := CObj(tempComplexObj.objLst[p]);
                    curComplexObj.Add( tmpObj );
                    tempComplexObj.objLst.Delete(p);
                  end;// for p
                  for p:=0 to complexObjects.ComplObjLst.Count-1 do begin
                    curComplexObj2 := CComplexObj(complexObjects.ComplObjLst[p]);
                    if curComplexObj2 = tempComplexObj then begin
                      complexObjects.ComplObjLst.Delete(p);
                      break;
                    end;
                  end; //p
                  tempComplexObj.objLst.Clear;
                  tempComplexObj.objLst.Free;
                  tempComplexObj.Free;
               end;
           end;



         end;//if( Tint > 0 ) and (Tint < 1e-15)


       end; //if (tmpS*1.0000000 - 2.0000000)  <= 0.00000000001
      end; //if curComplexObj <> tempComplexObj then begin


    end; //for i:=0 to ObjLst.Count-1 do begin
  end; //for j:=i to ObjLst.Count-1 do begin

  //                  

  fullLstX := CComplexObj.Create;
  fullLstY := CComplexObj.Create;
  curLstX := CComplexObj.Create;
  curLstY := CComplexObj.Create;

  for i:=0 to complexObjects.complObjLst.Count-1 do begin
     curComplexObj := CComplexObj(complexObjects.complObjLst[i]);
     for j:=0 to curComplexObj.objLst.Count-1 do begin
       curObj := CObj(curComplexObj.objLst[j]);
       if not fullLstX.IsObjInList(curObj) then begin
         fullLstX.Add( curObj );
         curLstX.Add( curObj );
       end;
       if not fullLstY.IsObjInList(curObj) then begin
         fullLstY.Add( curObj );
         curLstY.Add( curObj );
       end;
       for k:=j+1 to curComplexObj.objLst.Count-1 do begin
         tmpObj := CObj(curComplexObj.objLst[k]);
//         if curObj.x = tmpObj.x then
         if (SimpleRoundTo((curObj.x+curObj.sX-0.5 - tmpObj.x-tmpObj.sX-0.5) *
                     (tmpObj.x+tmpObj.sX-0.5 - curObj.x-curObj.sX-0.5), RoundToRange) > 0) then
           if not fullLstX.IsObjInList( tmpObj) then begin
             curLstX.Add( tmpObj );
             fullLstX.Add( tmpObj );
         end;
//         if curObj.y = tmpObj.y then
         if (SimpleRoundTo((curObj.y+curObj.sY-0.5 - tmpObj.y-tmpObj.sY-0.5) *
                     (tmpObj.y+tmpObj.sY-0.5 - curObj.y-curObj.sY-0.5), RoundToRange) > 0) then
           if not fullLstY.IsObjInList( tmpObj) then begin
             curLstY.Add( tmpObj );
             fullLstY.Add( tmpObj );
         end;
       end; //for k
       for m:=0 to curLstX.objLst.Count-1 do begin
         tmpObj :=  CObj(curLstX.objLst[m]);
         tmpObj.aY := curLstX.aY;
         tmpObj.vY := curLstX.vY;
         for n :=m+1 to curLstX.objLst.Count-1 do begin //   ,   
           curObj :=  CObj(curLstX.objLst[n]);
           if Abs(SimpleRoundTo(tmpObj.y + tmpObj.sY - curObj.y - curObj.sY, RoundToRange)) < 1 then
             curObj.sY := tmpObj.sY;
         end;//for n
       end; //for m
       curLstX.objLst.Clear;

       for m:=0 to curLstY.objLst.Count-1 do begin
         tmpObj :=  CObj(curLstY.objLst[m]);
         tmpObj.aX := curLstY.aX;
         tmpObj.vX := curLstY.vX;
         for n :=m+1 to curLstY.objLst.Count-1 do begin //   ,   
           curObj :=  CObj(curLstY.objLst[n]);
           if Abs(SimpleRoundTo(tmpObj.x + tmpObj.sX - curObj.x - curObj.sX, RoundToRange)) < 1 then
             curObj.sX :=  tmpObj.sX;
         end;//for n
       end; //for m
       curLstY.objLst.Clear;
     end; //for j -     
     fullLstX.objLst.Clear;
     fullLstY.objLst.Clear;
   end; //for j -    
   fullLstX.objLst.Free;
   fullLstY.objLst.Free;
   curLstX.objLst.Free;
   curLstY.objLst.Free;

   fullLstX.Free;
   fullLstY.Free;
   curLstX.Free;
   curLstY.Free;

end; //procedure CifGravityTrue.CreateComlexObjList;


procedure CComplexObj.SetV( vX, vY: Double); //      v
var j:Integer;
var curObj: CObj;
begin
    for j:=0 to objLst.Count - 1 do begin
      curObj := CObj(objLst[j]);
      curObj.vX := vX;
      curObj.vY := vY;
    end; //for j:=0 to curComplexObj.objLst.Count - 1 do begin
end; //  procedure SetV( v: Double); //      v


procedure CifGravityTrue.OneStep(
      ColCount, RowCount: Longint;
      var boolCell: TBoolField;  var trackCell: TBoolField;
      var nextPopulation: Longint;
      var bornPopulation, todPopulation: Integer );
var i, j, curStepsic, oldX, oldY: Longint;
var tmpM, tmpVx, tmpVy, minT, Tint, minS, sumEn, sumImpX, sumImpY: Double;
var BtmpM, BtmpVx, BtmpVy, BtmpName, BtmpColor: Boolean;
var questStr, valStr: string;
var obj1, obj2, hitObj:CObj;
var nighObj: TList;
var isMotion: Boolean;
var tmpColor : TColor;
var tmpName : String;
//var isIntersect: Boolean;



begin
  if not Assigned(ObjLst) then begin  //    
    ObjLst := TList.Create;
    complexObjects := CComplexObjList.Create;
    sumTime := 0;

//    SetLength(objFeald, ColCount, RowCount);

    tmpM := 1; tmpVx := 0; tmpVy := 0; tmpColor := clBlack; tmpName := '';
    BtmpM := true; BtmpVx := true; BtmpVy := true; BtmpColor := true; BtmpName := true;
    G := 1.0; //6.67408E-11;
    G := StrToFloat(InputBox('  ', 'G=', FloatToStr(G)));
    for  i:=0 to ColCount-1 do
      for j:=0 to RowCount-1 do begin
        if  boolCell[i,j] then begin
            boolCell[i,j] := false; trackCell[i,j] := true;
            fmInfField.sg.Refresh;


            fmAskBeginVal.Caption := '    ' + IntToStr(i) + ', ' + IntToStr(j);
            if BtmpName then begin
              fmAskBeginVal.lParamName.Caption := ':';
              fmAskBeginVal.edVal.Text := tmpName;
              fmAskBeginVal.ShowModal;
              BtmpName := fmAskBeginVal.rbIsForAll.Checked;
              tmpName := fmAskBeginVal.edVal.Text;
            end;
            if BtmpColor then begin
              fmAskBeginVal.lParamName.Caption := ' ';
              fmAskBeginVal.cdColor.Color := tmpColor;
              fmAskBeginVal.edVal.Visible := false;
              fmAskBeginVal.ShowModal;
              fmAskBeginVal.edVal.Visible := true;
              fmAskBeginVal.cdColor.Execute;
              BtmpColor := fmAskBeginVal.rbIsForAll.Checked;
              tmpColor := fmAskBeginVal.cdColor.Color;
            end;
            if BtmpM then begin
              fmAskBeginVal.lParamName.Caption := ':';
              fmAskBeginVal.edVal.Text := FloatToStr(tmpM);
              fmAskBeginVal.ShowModal;
              BtmpM := fmAskBeginVal.rbIsForAll.Checked;
              tmpM := StrToFloat(fmAskBeginVal.edVal.Text);
            end;
            if BtmpVx then begin
              fmAskBeginVal.lParamName.Caption := '   X:';
              fmAskBeginVal.edVal.Text := FloatToStr(tmpVx);
              fmAskBeginVal.ShowModal;
              BtmpVx := fmAskBeginVal.rbIsForAll.Checked;
              tmpVx := StrToFloat(fmAskBeginVal.edVal.Text);
            end;
            if BtmpVy then begin
              fmAskBeginVal.lParamName.Caption := '   Y:';
              fmAskBeginVal.edVal.Text := FloatToStr(tmpVy);
              fmAskBeginVal.ShowModal;
              BtmpVy := fmAskBeginVal.rbIsForAll.Checked;
              tmpVy := StrToFloat(fmAskBeginVal.edVal.Text);
            end;
            obj1 := CObj.Create(i,j,tmpVx, tmpVy,tmpM, tmpName, tmpColor);
            ObjLst.Add(obj1);

            boolCell[i,j] := true; trackCell[i,j] := false;
            fmInfField.sg.Refresh;

        end;
    end;
//    exit;
  end; //if not Assigned(Objects) then begin


//  todPopulation := complexObjects.complObjLst.Count;

//  CallForcePotenForAll; //       
  Stepsic := 1000;

//  if minT > 0 then begin
    isMotion:=false;
    curStepsic := 0;
    while  (isMotion = false) and (curStepsic < (Stepsic)) do begin
      curStepsic := curStepsic + 1;

      complexObjects.Clear;
//      complexObjects.complObjLst.Clear;
//      complexObjects.Free;

      CallForcePotenForAll; //       
      minT:= GetMinTimeStep(0.5);  //            
      minT:= minT/Stepsic;

      Tint := GetMinIntersectTime(minT);
      if Tint >= 0 then begin
        if Tint > 1e-20 then StepAll( Tint )
        else begin
          CreateComlexObjList( minT );
          minT := GetMinTimeStep(0.5);
          if minT <= 0 then break;
          minT := minT/Stepsic;
          Tint := GetMinComplexIntersectTime(minT);//GetMinIntersectTime(minT);
          if Tint <> -1 then StepAll( Tint )
          else StepAll( minT );
        end;
      end  
      else begin
       StepAll( minT );
      end;

  //  



  for i:=0 to ObjLst.Count-1 do begin
     obj1 := CObj(ObjLst[i]);


     if( (obj1.x >= 0) and (obj1.x < ColCount) and (obj1.y >= 0) and (obj1.y < RowCount) ) then begin
       boolCell[obj1.x, obj1.y] :=  false;
       trackCell[obj1.x, obj1.y] :=  true;
       oldX := obj1.x; oldY := obj1.y;
     end;

    if obj1.sX < -0.4999999999 then begin  // 1 , ..       
       obj1.x := obj1.x-1;
       obj1.sX := obj1.sX + 1;
       isMotion := true;
     end;
     if obj1.sX > 0.4999999999 then begin
       obj1.x := obj1.x+1;
       obj1.sX := obj1.sX - 1;
       isMotion := true;
     end;

     if obj1.sY < -0.4999999999 then begin
       obj1.y := obj1.y-1;
       obj1.sY := obj1.sY + 1;
       isMotion := true;
     end;
     if obj1.sY > 0.4999999999 then begin
       obj1.y := obj1.y+1;
       obj1.sY := obj1.sY - 1;
       isMotion := true;
     end;

     if( (obj1.x >= 0) and (obj1.x < ColCount) and (obj1.y >= 0) and (obj1.y < RowCount) ) then begin
       boolCell[obj1.x, obj1.y] :=  true;
       trackCell[obj1.x, obj1.y] :=  false;
       if (oldX <> obj1.x) or (oldY <> obj1.y) then
         if (GetObjXY( oldX, oldY ) <> nil) then begin
           boolCell[oldX, oldY] := true;
           trackCell[oldX, oldY] := false;
         end;
     end;

  end;    //for i:=0 to ObjLst.Count-1 do begin
end; // while not isMotion

//  if (not isMotion)
//    and ((fmInfField.step mod 10) <> 0) then begin
//      fmInfField.OneStep;
//  end;

//  end;//if minT > 0


  nextPopulation := ObjLst.Count;
  bornPopulation := complexObjects.complObjLst.Count;
//  todPopulation := nextPopulation - bornPopulation;

  fmInfField.sbMain.Panels[0].Text := ': ' + IntToStr(fmInfField.step) + '/' +
    IntToStr(StrToInt(fmInfField.edShowStep.Text)
     - (fmInfField.step mod StrToInt(fmInfField.edShowStep.Text)));

  if (fmInfField.step mod StrToInt(fmInfField.edShowStep.Text)) = 0 then begin
    fmInfField.sbMain.Panels[3].Text := Format(': %1.5e', [sumTime]);

    //      
    sumEn := 0;
    sumImpX := 0; sumImpY := 0;
    for i:=0 to ObjLst.Count-1 do begin
      obj1 := CObj(ObjLst[i]);
      sumEn :=  sumEn + SimpleRoundTo(obj1.m * (obj1.Vx*obj1.Vx + obj1.Vy*obj1.Vy) / 2, RoundToRange);
      sumImpX := sumImpX + SimpleRoundTo(obj1.m * obj1.Vx, RoundToRange);
      sumImpY := sumImpY + SimpleRoundTo(obj1.m * obj1.Vy, RoundToRange);
      for j:=i+1 to ObjLst.Count-1 do begin
         obj2 := CObj(ObjLst[j]);
         sumEn := sumEn - SimpleRoundTo(G * obj1.m * obj2. m /
           Sqrt( (obj1.x + obj1.sX - obj2.x - obj2.sX) * (obj1.x + obj1.sX - obj2.x - obj2.sX) +
                  (obj1.y + obj1.sY - obj2.y - obj2.sY) * (obj1.y + obj1.sY - obj2.y - obj2.sY) ), RoundToRange);
      end; //for j:=i+1
    end; //for i:=0
    fmInfField.sbMain.Panels[4].Text := Format(': %1.6e', [sumEn]);
    fmInfField.sbMain.Panels[5].Text := Format('.: %1.3e %1.3e', [sumImpX, sumImpY]);

  end;



end;




end.
