unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls, ToolWin, ComCtrls, Menus, Buttons, StdCtrls, BoolField,
  informationfield, ActnList;



type
  TfmInfField = class(TForm)
    ToolBar1: TToolBar;
    sbMain: TStatusBar;
    sg: TStringGrid;
    MainMenu: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    miOneStep: TMenuItem;
    sbStep: TSpeedButton;
    Label1: TLabel;
    edSleepTime: TEdit;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton4: TToolButton;
    bbClear: TBitBtn;
    ToolButton3: TToolButton;
    bbRandom: TBitBtn;
    shStart: TShape;
    bbStart: TBitBtn;
    cbVacuum: TCheckBox;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    Label2: TLabel;
    edShowStep: TEdit;
    ToolButton7: TToolButton;
    N3: TMenuItem;
    ToolButton8: TToolButton;
    miIsLife: TMenuItem;
    miIsGravity: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    ActionList: TActionList;
    acStep: TAction;
    miStart: TMenuItem;
    acStart: TAction;
    acClear: TAction;
    N6: TMenuItem;
    acSpray: TAction;
    N7: TMenuItem;
    acVacuum: TAction;
    N8: TMenuItem;
    N9: TMenuItem;
    acFieldLen: TAction;
    acAbout: TAction;
    N10: TMenuItem;
    odFiles: TOpenDialog;
    acFileSave: TAction;
    N12: TMenuItem;
    acFileLoad: TAction;
    N13: TMenuItem;
    miIsGravityTrue: TMenuItem;
    procedure sgSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure sgMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sgMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sgMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure sgDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure miOneStepClick(Sender: TObject);
    procedure miIsLifeClick(Sender: TObject);
    procedure miIsGravityClick(Sender: TObject);
    procedure acStepExecute(Sender: TObject);
    procedure acStartExecute(Sender: TObject);
    procedure acClearExecute(Sender: TObject);
    procedure acSprayExecute(Sender: TObject);
    procedure acVacuumExecute(Sender: TObject);
    procedure acFieldLenExecute(Sender: TObject);
    procedure acAboutExecute(Sender: TObject);
    procedure acFileSaveExecute(Sender: TObject);
    procedure acFileLoadExecute(Sender: TObject);
    procedure miIsGravityTrueClick(Sender: TObject);
  private
    { Private declarations }
    isMouseDown: Boolean;
    curGridCoord: TGridCoord;
    procedure SetCurInformationField( newIF:CInformatiomField );
  public
    { Public declarations }
    curIF: CInformatiomField;
    boolCell: TBoolField;
    trackCell: TBoolField;
    step: Longint;
    population: Longint;
    bornPopulation, todPopulation: Integer;
    procedure CreateBoolCell;

    procedure sgSetCellTrue(ACol, ARow: Integer);
    procedure OneStep;


 end;


var
  fmInfField: TfmInfField;

implementation

{$R *.DFM}
uses lifeThread, ifGravity, ifGravityTrue, ifLife, formFieldLength, formAbout;

procedure TfmInfField.CreateBoolCell;
begin
  if ifThread <> nil then begin
    ifThread.Free;
  end;
  SetLength(boolCell,sg.ColCount,sg.RowCount);
  SetLength(trackCell,sg.ColCount,sg.RowCount);
  ifThread := CLifeThread.Create(TRUE);

//  ifThread.Terminate;
//  if not ifThread.Suspended then ifThread.WaitFor;


end;


procedure TfmInfField.sgSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
 if isMouseDown = True then
 begin
   sgSetCellTrue(ACol, ARow);
 end;

end;

procedure TfmInfField.sgSetCellTrue(ACol, ARow: Integer);
begin
  if (ACol < 0) OR (ARow < 0) then exit;
  if Not boolCell[ACol, ARow] then
  begin
    sg.Canvas.Brush.Color :=  clBackGround;
    sg.Canvas.FillRect(sg.CellRect(ACol, Arow));
    boolCell[ACol, ARow] := True;
  end
  else
  begin
    sg.Canvas.Brush.Color := clWhite;
    sg.Canvas.FillRect(sg.CellRect(ACol, Arow));
    boolCell[ACol, ARow] := False;
  end;

end;


procedure TfmInfField.sgMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var gridCoord: TGridCoord;
begin
  isMouseDown := True;
  gridCoord := sg.MouseCoord(X, Y);
  sgSetCellTrue( gridCoord.X, gridCoord.Y);
  curGridCoord := gridCoord;
end;

procedure TfmInfField.sgMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var gridCoord: TGridCoord;
begin
  isMouseDown := False;
  gridCoord := sg.MouseCoord(X, Y);
  if (curGridCoord.X <> gridCoord.X) OR (curGridCoord.Y <> gridCoord.Y) then
    sgSetCellTrue( gridCoord.X, gridCoord.Y);

end;

procedure TfmInfField.sgMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var gridCoord: TGridCoord;
var i: Integer;
var obj1: CObj;

begin
 gridCoord := sg.MouseCoord(X, Y);
 sbMain.Panels[6].Text := 'X-Y: ' + IntToStr(gridCoord.X) + ' - ' + IntToStr(gridCoord.Y);
 sg.ShowHint := false;

 if miIsGravityTrue.checked then begin
   if Assigned(curIfGravityTrue.ObjLst) then for i:=0 to curIfGravityTrue.ObjLst.Count-1 do begin
     obj1 := CObj(curIfGravityTrue.ObjLst[i]);
     if (obj1.x = gridCoord.X) and (obj1.y = gridCoord.Y) then begin
       sbMain.Panels[6].Text := Format('%d-%d m=%1.4e vX=%1.3e vY=%1.3e aX=%.4e aY=%.4e sX=%.2f sY=%.2f',
          [obj1.x, obj1.y, obj1.m, obj1.vX, obj1.vY, obj1.aX, obj1.aY, obj1.sX, obj1.sY]);
       sg.Hint := Format('%s sX=%.2f sY=%.2f V=%1.3e', [obj1.name, obj1.sX, obj1.sY, Sqrt(obj1.vX*obj1.vX+obj1.vY*obj1.vY)]);
       sg.ShowHint := true;
       break;
     end; //if
   end; //for i
 end;

 if isMouseDown = True then
 begin
  if (curGridCoord.X <> gridCoord.X) OR (curGridCoord.Y <> gridCoord.Y) then
  begin
   sgSetCellTrue( gridCoord.X, gridCoord.Y);
   curGridCoord := gridCoord;
  end;
 end;


end;

procedure TfmInfField.sgDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
  var i: Longint;
  var obj1: CObj;
begin
//  for  i:=0 to sg.ColCount-1 do
//    for j:=0 to sg.RowCount-1 do begin



      if boolCell[ACol,ARow] then  begin
        sg.Canvas.Brush.Color :=  clBackGround;
        if miIsGravityTrue.checked then begin
          if Assigned(curIfGravityTrue.ObjLst) then begin
            obj1 := curIfGravityTrue.GetObjXY(ACol, ARow);
            if obj1 <> nil then sg.Canvas.Brush.Color :=  obj1.Color;
          end;
        end; //if miIsGravityTrue.checked
      end
      else begin
        sg.Canvas.Brush.Color :=  clWhite;
        if trackCell[ACol,ARow] then sg.Canvas.Brush.Color :=  clBlue;
      end;

      sg.Canvas.FillRect(sg.CellRect(ACol,ARow));


end;


procedure TfmInfField.OneStep;
var isVacuum: Boolean;
var nextPopulation: Longint;
var neighbourNum: array[0..7, 0..1] of Integer;
var i, j, l: Longint;

begin
  Inc(step);
  
  curIF.OneStep(
   sg.ColCount, sg.RowCount,
   boolCell, trackCell,
   nextPopulation,
   bornPopulation, todPopulation);


  if cbVacuum.Checked then begin // 
   for  i:=0 to sg.ColCount-1 do
    for j:=0 to sg.RowCount-1 do begin
      neighbourNum[0, 0] := i-1;
      neighbourNum[0, 1] := j;
      neighbourNum[1, 0] := i-1;
      neighbourNum[1, 1] := j-1;
      neighbourNum[2, 0] := i;
      neighbourNum[2, 1] := j-1;
      neighbourNum[3, 0] := i+1;
      neighbourNum[3, 1] := j-1;
      neighbourNum[4, 0] := i+1;
      neighbourNum[4, 1] := j;
      neighbourNum[5, 0] := i+1;
      neighbourNum[5, 1] := j+1;
      neighbourNum[6, 0] := i;
      neighbourNum[6, 1] := j+1;
      neighbourNum[7, 0] := i-1;
      neighbourNum[7, 1] := j+1;

      isVacuum := false;
      for l:=0 to 7 do begin
        if neighbourNum[l,0] < 0 then neighbourNum[l,0] := sg.ColCount-1;
        if neighbourNum[l,0] > sg.ColCount-1 then neighbourNum[l,0] := 0;
        if neighbourNum[l,1] < 0 then neighbourNum[l,1] := sg.RowCount-1;
        if neighbourNum[l,1] > sg.RowCount-1 then neighbourNum[l,1] := 0;
        if boolCell[neighbourNum[l,0], neighbourNum[l,1]] then  begin
          isVacuum := true;
          break;
        end;

      end;

      if not isVacuum then begin
        if random < (0.5/(sg.ColCount*sg.RowCount)) then begin // 
          boolCell[neighbourNum[1,0], neighbourNum[1,1]] := true;
          boolCell[neighbourNum[3,0], neighbourNum[3,1]] := true;
          boolCell[neighbourNum[5,0], neighbourNum[5,1]] := true;
          boolCell[neighbourNum[7,0], neighbourNum[7,1]] := true;
          bornPopulation := bornPopulation+4;
        end;
      end;
    end;   //for i,j

  end;  //if cbVacuum.Checked then begin

// 

try
  if (step mod StrToInt(edShowStep.Text)) = 0 then begin
    shStart.Brush.Color := RGB(step mod 255, random(255), random(255));
    sg.Refresh;

    sbMain.Panels[0].Text := ': ' + IntToStr(step);
    sbMain.Panels[1].Text := ' (.): ' + IntToStr(nextPopulation);
    if not miIsGravityTrue.checked then begin
      sbMain.Panels[2].Text := ' (.): ' + IntToStr(bornPopulation) +
                             ',  (.): ' + IntToStr(todPopulation) +
                             ',  (.): ' + IntToStr(bornPopulation-todPopulation) ;

//    if step mod 10 = 0 then
      if (population = 0) AND (nextPopulation > 0) then begin
        sbMain.Panels[3].Text := ' (.): ' + IntToStr(step);
      end
      else if  (population > 0) AND (nextPopulation = 0) then begin
        sbMain.Panels[4].Text := ' (.): ' + IntToStr(step);
      end
      else if  (population = nextPopulation) AND (population <> 0) then begin
        sbMain.Panels[5].Text := ' (.): ' + IntToStr(step);
      end;
    end
    else begin
      sbMain.Panels[2].Text := '  (.): ' + IntToStr(bornPopulation);
    end; //if not miIsGravityTrue.checked then begin

  end;  //if (step mod StrToInt(edShowStep.Text)) = 0 then begin
except
  on  EConvertError do;
  on EDivByZero do;
end;


  population:=nextPopulation;


end;



procedure TfmInfField.miOneStepClick(Sender: TObject);
begin
  OneStep;
end;





procedure TfmInfField.miIsLifeClick(Sender: TObject);
begin
//  if miIsLife.checked then exit;
  miIsLife.checked := true;
  Caption := 'Information field -   ""';
  if curIfLife = nil then curIfLife := CifLife.Create;
  SetCurInformationField( curIfLife );


end;

procedure TfmInfField.miIsGravityClick(Sender: TObject);
begin
//  if miIsGravity.checked then exit;
  miIsGravity.checked := true;
  Caption := 'Information field -   ""';
  if curIfGravity = nil then curIfGravity := CifGravity.Create;
  SetCurInformationField( curIfGravity );

end;



procedure TfmInfField.miIsGravityTrueClick(Sender: TObject);
begin
//  if miIsGravityTrue.checked then exit;
  miIsGravityTrue.checked := true;
  Caption := 'Information field -   " "';
  curIfGravityTrue.Free;// := nil; 
  //  if curIfGravityTrue = nil then
  curIfGravityTrue := CifGravityTrue.Create;
  SetCurInformationField( curIfGravityTrue );

end;



procedure TfmInfField.SetCurInformationField( newIF:CInformatiomField );
begin

// ifThread.Terminate;
//  if not ifThread.Suspended then ifThread.WaitFor;
  ifThread.Free;
  ifThread := CLifeThread.Create(TRUE);
  curIF := newIF;

end;


procedure TfmInfField.acStepExecute(Sender: TObject);
begin
 Screen.Cursor := crHourGlass;
 acStep.Caption := ''; 
 OneStep;
 Screen.Cursor := crDefault;
 acStep.Caption := '&';
end;

procedure TfmInfField.acStartExecute(Sender: TObject);
begin
  if ifThread.Suspended then begin
    acStart.Caption := '&';
    ifThread.Resume;
    acFileLoad.Enabled := False;
  end
  else begin
    ifThread.Suspend;
    edShowStep.Text := '1';
    step := step-1;
    acStart.Caption := '';
    acStart.Update;
    Screen.Cursor := crHourGlass;
    OneStep;
    acStart.Caption := '&';
    shStart.Brush.Color := clBtnFace;
    acFileLoad.Enabled := True;
    Screen.Cursor := crDefault;
  end;

end;

procedure TfmInfField.acClearExecute(Sender: TObject);
var i, j: Longint;
begin
  for  i:=0 to sg.ColCount-1 do
    for j:=0 to sg.RowCount-1 do begin
      boolCell[i,j] := False;
      trackCell[i,j] := False;
  end;
  step := 0;
  sbMain.Panels[0].Text := ': ' + IntToStr(step);
  sbMain.Panels[3].Text := '';
  sbMain.Panels[4].Text := '';
  sbMain.Panels[5].Text := '';
  sg.Refresh;
  miIsGravityTrueClick(Sender);
end;

procedure TfmInfField.acSprayExecute(Sender: TObject);
var i, j: Longint;
begin
  for  i:=0 to sg.ColCount-1 do
    for j:=0 to sg.RowCount-1 do begin
      boolCell[i,j] := (Random>=0.5);
  end;
  sg.Refresh;

end;

procedure TfmInfField.acVacuumExecute(Sender: TObject);
begin
  acVacuum.Checked := (Not acVacuum.Checked); 
end;

procedure TfmInfField.acFieldLenExecute(Sender: TObject);
var newColCount: Integer;
    newCellSize: Integer;
begin
  fmFieldLength.edNum.Text := IntToStr(sg.ColCount);
  fmFieldLength.edSize.Text := IntToStr(sg.DefaultColWidth);
  fmFieldLength.ShowModal;
  if fmFieldLength.edNum.Text = 'cancel' then exit;
  newColCount := StrToInt(fmFieldLength.edNum.Text);
  if newColCount <> sg.ColCount then begin
    sg.ColCount := newColCount;
    sg.RowCount := newColCount;
    CreateBoolCell;
  end;
  newCellSize := StrToInt(fmFieldLength.edSize.Text);
  if newCellSize <> sg.DefaultColWidth then begin
    sg.DefaultColWidth := newCellSize;
    sg.DefaultRowHeight := newCellSize;
    sg.Refresh;
  end;
end;

procedure TfmInfField.acAboutExecute(Sender: TObject);
begin
  fmAbout.ShowModal;
end;

procedure TfmInfField.acFileSaveExecute(Sender: TObject);
var f: TextFile;
var    i, j: Integer;
var obj1: CObj;
var strStep: String;

begin
  if odFiles = nil then odFiles :=  TOpenDialog.Create(self);
  if odFiles.Execute then begin
    AssignFile( f, odFiles.FileName);
    ReWrite(f);
    WriteLn(f, IntToStr(sg.ColCount));
    WriteLn(f, IntToStr(sg.RowCount));
    for j:=0 to sg.RowCount-1 do begin
       for i:=0 to sg.ColCount-1 do begin
         Write(f, IntToStr(Integer(boolCell[i,j])));
       end; //for i
       WriteLn(f);
    end; //for j

 if miIsGravityTrue.checked then begin
   if Assigned(curIfGravityTrue.ObjLst) then begin
    for j:=0 to sg.RowCount-1 do begin
       for i:=0 to sg.ColCount-1 do begin
         Write(f, IntToStr(Integer(trackCell[i,j])));
       end; //for i
       WriteLn(f);
    end; //for j


     WriteLn(f, FloatToStr(curIfGravityTrue.G));
//     if step <> 0 then step := step - 1;
     j :=  Pos(' ', sbMain.Panels[0].Text );
     strStep := Copy(sbMain.Panels[0].Text, j, Length(sbMain.Panels[0].Text) - j+1);
     WriteLn(f, strStep );
//     if step <> 0 then step := step + 1;
     WriteLn(f, FloatToStr(curIfGravityTrue.sumTime));

     WriteLn(f, IntToStr(curIfGravityTrue.ObjLst.Count));
     for i:=0 to curIfGravityTrue.ObjLst.Count-1 do begin
       obj1 := CObj(curIfGravityTrue.ObjLst[i]);
       WriteLn(f, obj1.name);
       WriteLn(f, IntToStr(obj1.color));
       WriteLn(f, IntToStr(obj1.x));
       WriteLn(f, IntToStr(obj1.y));
       WriteLn(f, FloatToStr(obj1.vX));
       WriteLn(f, FloatToStr(obj1.vY));
       WriteLn(f, FloatToStr(obj1.m));
       WriteLn(f, FloatToStr(obj1.sX)); WriteLn(f, FloatToStr(obj1.sY));
       WriteLn(f, FloatToStr(obj1.aX)); WriteLn(f, FloatToStr(obj1.aY));
     end; //for i
   end; //if Assigned
 end; //if miIsGravityTrue.checked then begin


    CloseFile(f);

  end;
end;


procedure TfmInfField.acFileLoadExecute(Sender: TObject);
var f: TextFile;
    i, j, itCol, itRow, maxCol, maxRow: Longint;
    text, name: String;
    ch: Char;
    posStr: String;
    x,y: Longint;
    vX, vY, aX, aY, sX, sY, m: Double;
    obj1: CObj;
    color: TColor;
begin
  if odFiles = nil then odFiles :=  TOpenDialog.Create(self);
try
  if odFiles.Execute then begin
    AssignFile( f, odFiles.FileName);
    Reset(f);

    case  odFiles.FilterIndex of
1: //if-file
begin
    ReadLn(f, text);
    itCol := StrToInt(text);
    if itCol > sg.ColCount then sg.ColCount := itCol;

    ReadLn(f, text);
    itRow := StrToInt(text);
    if itRow > sg.RowCount then sg.RowCount := itRow;

    CreateBoolCell;

    for j:=0 to itRow-1 do begin
       for i:=0 to itCol-1 do begin
         Read(f, ch);
         if ch = '0' then boolCell[i,j] := False else boolCell[i,j] := True;
       end; //for i
       ReadLn(f);
    end; //for j

 if miIsGravityTrue.checked then begin
    for j:=0 to itRow-1 do begin
       for i:=0 to itCol-1 do begin
         Read(f, ch);
         if ch = '0' then trackCell[i,j] := False else trackCell[i,j] := True;
       end; //for i
       ReadLn(f);
    end; //for j


     ReadLn(f, text); curIfGravityTrue.G := StrToFloat(text);
     ReadLn(f, text); step := StrToInt(text); sbMain.Panels[0].Text := ': ' + IntToStr(step);
     ReadLn(f, text); curIfGravityTrue.sumTime := StrToFloat(text);
     fmInfField.sbMain.Panels[3].Text := Format(': %1.4e', [curIfGravityTrue.sumTime]);

     ReadLn(f, text); maxCol := StrToInt(text);
     if Not Assigned(curIfGravityTrue.ObjLst) then curIfGravityTrue.ObjLst := TList.Create;
     curIfGravityTrue.ObjLst.Clear;
     if Not Assigned(curIfGravityTrue.complexObjects) then curIfGravityTrue.complexObjects := CComplexObjList.Create;
     curIfGravityTrue.complexObjects.Clear;
     curIfGravityTrue.complexObjects.complObjLst.Clear;


     for i:=0 to maxCol-1 do begin
       ReadLn(f, text); name := text;
       ReadLn(f, text); color := StrToInt(text);

       ReadLn(f, text); x := StrToInt(text);
       ReadLn(f, text); y := StrToInt(text);
       ReadLn(f, text); vX := StrToFloat(text);
       ReadLn(f, text); vY := StrToFloat(text);
       ReadLn(f, text); m := StrToFloat(text);
       ReadLn(f, text); sX := StrToFloat(text);
       ReadLn(f, text); sY := StrToFloat(text);
       ReadLn(f, text); aX := StrToFloat(text);
       ReadLn(f, text); aY := StrToFloat(text);

       obj1 := CObj.Create(x,y,vX, vY, m, name, color);
       obj1.aX := aX; obj1.aY := aY; obj1.sX:=sX; obj1.sY := sY;
       curIfGravityTrue.ObjLst.Add(obj1);

     end; //for i
 end; //if miIsGravityTrue.checked then begin



end; //0
2: //lif-file
begin
    maxCol := 0; maxRow := 0;
    while not Eof(f) do begin
     ReadLn(f, text);
     if text[1] = '#' then begin
       if text[2] = 'P' then begin
         posStr := '';
         for i:=4 to Length(text) do begin
           if text[i] = ' ' then break;
           posStr := posStr + text[i];
         end;
         itCol := Abs(StrToInt(posStr));
         posStr := '';
         for i:=i+1 to Length(text) do begin
           if text[i] = ' ' then break;
           posStr := posStr + text[i];
         end;
         itRow := Abs(StrToInt(posStr));
       end;
       continue;
     end;
     if maxCol < ((itCol+Length(text))*2) then maxCol := 2*(itCol+Length(text));
     Inc(itRow);
     if maxRow < (2*itRow) then maxRow := 2*itRow;
   end; //while
   Reset(f);
   if sg.ColCount < maxCol  then sg.ColCount := maxCol;
   if sg.RowCount < maxRow  then sg.RowCount := maxRow;
   CreateBoolCell;

    itRow := sg.RowCount div 2;
    itCol := sg.ColCount div 2;
    while not Eof(f) do begin
     ReadLn(f, text);
     if text[1] = '#' then begin
       if text[2] = 'P' then begin
         posStr := '';
         for i:=4 to Length(text) do begin
           if text[i] = ' ' then break;
           posStr := posStr + text[i];
         end;
         itCol := (sg.ColCount div 2) + StrToInt(posStr);
         posStr := '';
         for i:=i+1 to Length(text) do begin
           if text[i] = ' ' then break;
           posStr := posStr + text[i];
         end;
         itRow := (sg.RowCount div 2) + StrToInt(posStr);
       end;
       continue;
     end;
     for i := 1 to Length(text) do begin
       if text[i] = '.' then  boolCell[itCol+i-1,itRow] := false else boolCell[itCol+i-1,itRow] := true;
     end;
     Inc(itRow);
   end; //while

end; //1
    end; //case  odFiles.FilterIndex of



    CloseFile(f);
    Caption := 'Information field -  ' + odFiles.FileName;

    sg.Refresh;
  end;//if odFiles.Execute then begin
except
  on E: Exception do ShowMessage( E.Message );
end;
end;


end.
